@echo off
call :clearvar

cd /d "%~dp0"
setlocal enableextensions enabledelayedexpansion

::admin_req
call :ensure_admin

if exist q2pro.exe goto :q2pro_true
if exist r1q2.exe goto :r1q2_true
if not exist r1q2.exe call :die "No se encuentra ningun ejecutable."

:q2pro_true
reg query "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\q2pro.exe"
if %errorlevel%==0 goto :uns_intro_q2pro
if %errorlevel%==1 goto :ins_intro_q2pro

:r1q2_true
reg query "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\r1q2.exe"
if %errorlevel%==0 goto :uns_intro_r1q2
if %errorlevel%==1 goto :ins_intro_r1q2

:ins_intro_q2pro
cls
echo.
echo =======================================================================
echo               Instalador de Q2Online para Windows [Q2PRO]
echo =======================================================================
echo.  
echo Bienvenido al Instalador de Q2Online.
echo.
echo A continuacion se instalara Q2Online en su sistema operativo. Este
echo instalador registrara Q2PRO en su directorio actual y creara los
echo accesos directos correspondientes en escritorio y menu de inicio.
echo.
echo Q2Online se instalara en:
echo %cd%
echo.
echo Para cambiar el directorio de instalacion, cierre el instalador y
echo ubique el directorio de Q2Online donde desea instalarlo.
echo.
choice /c SN /m "Desea continuar la instalacion"
if %errorlevel%==1 goto :q2pro_dir
if %errorlevel%==2 call :die "Operacion finalizada por el Usuario"
echo.
echo =======================================================================


:q2pro_dir
set q2o_path=%~dp0q2pro.exe
set clapp=q2pro
set CLLNK=Q2PRO

::regedit
echo.
echo =======================================================================
echo.
echo Agregando al registro...
set app_paths_key=HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\%clapp%.exe
call :reg add "%app_paths_key%" /d "%q2o_path%" /f
call :reg add "%app_paths_key%" /v "UseUrl" /t REG_DWORD /d 1 /f

::lnk
echo Creando accesos directos...
echo.
call :diracc
call :insver

::desinstalar

:uns_intro_q2pro
cls
echo.
echo =======================================================================
echo            Instalador de Q2Online para Windows [DESINSTALAR]
echo =======================================================================
echo.
echo Se ha encontrado una version del cliente Q2PRO en su sistema operativo. 
echo A continuacion, el instalador eliminara el cliente del registro del
echo sistema y los accesos directos creados al momento de la instalacion.
echo.
echo No se eliminara ningun archivo contenido dentro del directorio de 
echo Q2Online.
echo.
echo Si desea eliminar completamente Q2Online de su sistema, borre el
echo directorio de Q2Online una vez finalizado el proceso de desinstalacion.
echo.
choice /c SN /m "Desea continuar la desinstalacion"
if %errorlevel%==1 goto :q2pro_uninstall
if %errorlevel%==2 call :die "Operacion finalizada por el Usuario"
echo.
pause


:q2pro_uninstall
::regedit
echo.
echo =======================================================================
reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\q2pro.exe" /f >nul
echo.
echo Borrando del registro...

::lnk
echo Borrando accesos directos...
if not exist "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online" set deserror_dir=1
if not exist "%homepath%\Desktop\Q2PRO.lnk" set deserror_lnk=1

rmdir /S /Q "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online"
del /S /Q "%homepath%\Desktop\Q2PRO.lnk"

call :desver

:ins_intro_r1q2
cls
echo.
echo =======================================================================
echo               Instalador de Q2Online para Windows [R1Q2]
echo =======================================================================
echo.  
echo Bienvenido al Instalador de Q2Online.
echo.
echo A continuacion se instalara Q2Online en su sistema operativo. Este
echo instalador registrara R1Q2 en su directorio actual y creara los
echo accesos directos correspondientes en escritorio y menu de inicio.
echo.
echo Q2Online se instalara en:
echo %cd%
echo.
echo Para cambiar el directorio de instalacion, cierre el instalador y
echo ubique el directorio de Q2Online donde desea instalarlo.
echo.
choice /c SN /m "Desea continuar la instalacion"
if %errorlevel%==1 goto :r1q2_dir
if %errorlevel%==2 call :die "Operacion finalizada por el Usuario"
echo.
echo =======================================================================


:r1q2_dir
set q2o_path=%~dp0r1q2.exe
set clapp=r1q2
set CLLNK=R1Q2

::regedit
echo.
echo =======================================================================
echo.
echo Agregando al registro...
set app_paths_key=HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\%clapp%.exe
call :reg add "%app_paths_key%" /d "%q2o_path%" /f
call :reg add "%app_paths_key%" /v "UseUrl" /t REG_DWORD /d 1 /f

::lnk
echo Creando accesos directos...
echo.
call :diracc
call :insver

:uns_intro_r1q2
cls
echo.
echo =======================================================================
echo            Instalador de Q2Online para Windows [DESINSTALAR]
echo =======================================================================
echo.
echo Se ha encontrado una version del cliente R1Q2 en su sistema operativo. 
echo A continuacion, el instalador eliminara el cliente del registro del
echo sistema y los accesos directos creados al momento de la instalacion.
echo.
echo No se eliminara ningun archivo contenido dentro del directorio de 
echo Q2Online.
echo.
echo Si desea eliminar completamente Q2Online de su sistema, borre el
echo directorio de Q2Online una vez finalizado el proceso de desinstalacion
echo.
choice /c SN /m "Desea continuar la desinstalacion"
if %errorlevel%==1 goto :r1q2_uninstall
if %errorlevel%==2 call :die "Operacion finalizada por el Usuario"
echo.
pause

:r1q2_uninstall
::regedit
echo.
echo =======================================================================
reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\r1q2.exe" /f >nul
echo.
echo Borrando del registro...

::lnk
echo Borrando accesos directos...
if not exist "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online" set deserror_dir=1
if not exist "%homepath%\Desktop\R1Q2.lnk" set deserror_lnk=1
rmdir /S /Q "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online"
del /S /Q "%homepath%\Desktop\R1Q2.lnk"

call :desver

:desend_error
call :clearvar
echo.
echo =======================================================================
echo.
echo El cliente fue eliminado existosamente del registro, pero el directorio
echo "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online" y el
echo acceso directo del cliente, creados al momento de la instalacion, no 
echo se encontraron en el sistema.
echo.
pause
exit 1

:desend_direrror
call :clearvar
echo.
echo =======================================================================
echo.
echo El cliente fue eliminado existosamente del registro, pero el directorio
echo "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online", creado 
echo al momento de la instalacion, no se encontro en el sistema.
echo.
pause
exit 1

:desend_lnkerror
call :clearvar
echo.
echo =======================================================================
echo.
echo El cliente fue eliminado existosamente del registro, pero el acceso 
echo directo del cliente, creado al momento de la instalacion, no se 
echo encontro en el sistema.
echo.
pause
exit 1

:desend
call :clearvar
echo.
echo =======================================================================
echo.
echo Q2Online se desinstalo correctamente
echo.
pause
exit 0

:insend_error
call :clearvar
echo =======================================================================
echo.
echo El cliente fue agregado exitosamente al registro de Windows, pero se 
echo presentaron los siguientes errores durante la instalacion:
echo.
echo	* No fue posible crear el directorio "Q2Online" en el menu de inicio.
echo	* No fue posible crear el acceso directo en Escritorio
echo.
echo Esto puede deberse a que ya existen los archivos que el instalador
echo intenta crear o incompatibilidad entre este script y el sistema.
echo.
echo Se recomienda verificar los puntos mencionados.
echo.
pause
exit 1

:insend_direrror
call :clearvar
echo.
echo =======================================================================
echo.
echo El cliente fue agregado exitosamente al registro de Windows, pero se 
echo presento el siguiente problema durante la instalacion:
echo.
echo	* No fue posible crear el directorio "Q2Online" en el menu de inicio.
echo.
echo Esto puede deberse a que ya existe el directorio que el instalador
echo intenta crear o incompatibilidad entre este script y el sistema.
echo.
echo Se recomienda verificar lo mencionado.
echo.
pause
exit 1

:insend_lnkerror
call :clearvar
echo.
echo =======================================================================
echo.
echo El cliente fue agregado exitosamente al registro de Windows, pero se 
echo presento el siguiente problema durante la instalacion:
echo.
echo	* No fue posible crear el acceso directo en Escritorio
echo.
echo Esto puede deberse a que ya existe el archivo que el instalador
echo intenta crear o incompatibilidad entre este script y el sistema.
echo.
echo Se recomienda verificar lo mencionado.
echo.
pause
exit 1

:insend
call :clearvar
echo =======================================================================
echo.
echo La instalacion ha finalizado
echo Si desea desinstalar Q2Online vuelva a ejecutar este archivo.
echo.
echo Felices frags
echo.
pause
exit 0

:die
	cls
	if not [%1] == [] echo %~1
	if [%unattended%] == [yes] exit 1
	exit 1

:ensure_admin
	openfiles >nul 2>&1
	if errorlevel 1 (
		echo Debes ejecutar este archivo como administrador.
		pause
		call :die
	)
	goto:eof

:reg
	:: Wrap the reg command to check for errors
	>nul reg %*
	if errorlevel 1 set error=yes
	if [%error%] == [yes] echo Error in command: reg %*
	if [%error%] == [yes] call :die
	goto:eof
	
:clearvar

	set "q2o_path="
	set "app_paths_key="
	set "inserror="
	set "inserror_dir="
	set "inserror_lnk="
	set "deserror="
	set "deserror_dir="
	set "deserror_lnk="
	set "error="
	set "clapp="
	set "CLLNK="
	goto:eof
	
:diracc
	if exist "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online" set inserror_dir=1
	if exist "%homepath%\Desktop\%CLLNK%.lnk" set inserror_lnk=1
	mkdir "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online"
	echo Set oWS = WScript.CreateObject("WScript.Shell") >> setup.vbs
	echo sLinkFile = "%homepath%\Desktop\%CLLNK%.lnk" >> setup.vbs
	echo Set oLink = oWS.CreateShortcut(sLinkFile) >> setup.vbs
	echo oLink.TargetPath = "%~dp0%clapp%.exe" >> setup.vbs
	echo oLink.WorkingDirectory = "%~dp0" >> setup.vbs
	echo oLink.Save >> setup.vbs
	cscript setup.vbs
	copy "%homepath%\Desktop\%CLLNK%.lnk" "C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Q2Online\%CLLNK%.lnk" >nul
	del setup.vbs
	goto:eof

:desver
if [%deserror_dir%] == [1] (
    if [%deserror_lnk%] == [1] (
        set deserror=1
    )
)
if "%deserror%"=="1" (goto:desend_error)
if "%deserror_dir%"=="1" (goto:desend_direrror)
if "%deserror_lnk%"=="1" (goto:desend_lnkerror
) else (goto:desend
)


:insver
if [%inserror_dir%] == [1] (
    if [%inserror_lnk%] == [1] (
        set inserror=1
    )
)
if "%inserror%"=="1" (goto:insend_error)
if "%inserror_dir%"=="1" (goto:insend_direrror)
if "%inserror_lnk%"=="1" (goto:insend_lnkerror
) else (goto:insend
)